#!/usr/bin/perl -w

###############################################################################
#
#     Proxy::Config.pm
#  
#  Description: 
#
#     blaaaah blaaah....
#
#  Usage:
#
#      Proxy::Config.pm [<args>]
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License (http://www.gnu.org/copyleft/gpl.html)
#  for more details
#
#  Author        : Dirk Barnikel <dirk.barnikel@gmx.de>
#  Created       : Wed Nov 24 18:26:59 1999 (scratch.barny.net)
#  Last Modified : Wed Nov 24 18:26:59 1999 by Dirk Barnikel
#  Revision      : 0.01
#  
#  CHANGES:
#
#  Wed Nov 24 18:26:59 1999 (Dirk Barnikel):
#
#    * Proxy::Config.pm 0.01 created.
#
###############################################################################

package Proxy::Config;
use strict;
use vars qw($VERSION $DEBUG);

$Proxy::Config::VERSION = 0.01;
$Proxy::Config::DEBUG   = 0;


##################################################################################################
#
package Proxy::Config;
#
##################################################################################################

use vars qw(
	    $ConfigFile 
	    %ForwardRules 
	    $LogFile 
	    $UseLog 
	    $UseConsole
	    $UseMonitor
	    $UseAPI  
	    $Timeout 
	    $RunInBackground
	    $CheckPort
	    $MonitorPort
	    $MonitorPass
	    $PidFile
	    $Hostname
	    $Debugging
	    $AdminPass
	    $AdminPort
	    $RulesFile
	    $Extensions
	    $ExtensionsFile
	    $__VERSION
	    $__IO_BLOCKSIZE
	    @__IO_SOCKETOPTS
	    $__HAVE_MOD_API
	    $__HAVE_MOD_ADMIN
	    $__HAVE_MOD_MONITOR
	   );

# internal!!
$__IO_BLOCKSIZE     = int(8192) ;
@__IO_SOCKETOPTS    = ( Proto  => 'tcp' , Listen => 1 , Reuse     => 1 );
$__VERSION          = "0.71";
$__HAVE_MOD_ADMIN   = 0;
$__HAVE_MOD_MONITOR = 0;
$__HAVE_MOD_API     = 0;
$Extensions         = {};
# user configurable
$UseLog          = 1 ;
$UseConsole      = 1 ;
$UseMonitor      = 1 ;
$UseAPI          = 1 ;
$Timeout         = 5 ;
$RunInBackground = 0 ;
$CheckPort       = 22022 ;
#$AdminPort       = undef;
#$MonitorPort     = undef;
$ConfigFile      = $ARGV[0] || $ENV{HOME} . "/.aproxyrc" ;
$RulesFile       = $ARGV[1] || $ENV{HOME} . "/.aproxyrules" ;
$ExtensionsFile  = $ARGV[2] || $ENV{HOME} . "/.aproxyextensions";
$PidFile         = $ENV{HOME} . "/aproxy.pid" ;
$LogFile         = undef ; # $ENV{HOME} . "/aproxy.log" ;
$Debugging       = undef;
$Hostname        = `hostname -f` ; chomp($Hostname);

####################################
#$MonitorPass     = undef;
#$AdminPass       = undef;
####################################

sub loadConfigfile { require $ConfigFile || die "Error in configuration ($ConfigFile): $@\n" }
sub loadRulesfile  { require $RulesFile  || die "Error in rules-file ($RulesFile): $@\n"     }
sub saveRulesfile  
  { 
    my $filename = $RulesFile ;
    my($localport,$host_ref, $host,$port);
     
    open( RULES , ">" . $filename ) || return undef;
    
    print RULES 
      "########################################################\n",
      "# $RulesFile\n",
      "# autogenerated at " . scalar localtime() , "\n",
      "########################################################\n",
      "\n",
      "*R = *Proxy::Config::ForwardRules;\n",
      "\n";
    while( ($localport,$host_ref) = each %Proxy::Config::ForwardRules )
      {
	my($host,$port) = @$host_ref ;
	print RULES "\$R{$localport} = [ \"$host\" , $port ];\n";	
      }
    print RULES
      "\n1;\n",
      "# at EOF\n";
    
    close(RULES);
    return $filename
  }
1;

__END__


