#!/usr/bin/perl -w

###############################################################################
#
#     Proxy::Log
#  
#  Description: 
#
#     blaaaah blaaah....
#
#  Usage:
#
#      Proxy::Log [<args>]
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License (http://www.gnu.org/copyleft/gpl.html)
#  for more details
#
#  Author        : Dirk Barnikel <dirk.barnikel@gmx.de>
#  Created       : Wed Nov 24 00:23:55 1999 (scratch.barny.net)
#  Last Modified : Wed Nov 24 00:23:55 1999 by Dirk Barnikel
#  Revision      : 0.01
#  
#  CHANGES:
#
#  Wed Nov 24 00:23:55 1999 (Dirk Barnikel):
#
#    * Proxy::Log 0.01 created.
#
###############################################################################

package Proxy::Log;
use strict;

use Proxy::Config;

use vars qw($VERSION $DEBUG $LastMessage);

$Proxy::Log::VERSION     = 0.01;
$Proxy::Log::DEBUG       = 0;
$Proxy::Log::LastMessage = "";

sub import
  {
    my $caller = caller();
    no strict 'refs';
    *{"${caller}::log_event"} = *Proxy::Log::log_event ;
  }

sub open_log
  {
    my $logfile = shift ;
    open( LOGFILE , ">>" . $logfile )
      || die "Can't open Logfile $logfile\n";
    select(LOGFILE) unless defined($Proxy::Config::Debugging);
    $| = 1;
    &log_event("--- MARK (begin PID $$) ---");
  }


sub log_event  
  {    
    my $logstring = join(" " , "" , @_ );      
    
    $LastMessage = $logstring;
    $logstring   = scalar(localtime()) . $LastMessage; 
    
    if($Proxy::Config::UseLog)
      {
	print $logstring , "\n" 
      }
   # if(defined($Proxy::Admin::Monitor::MonitorSocks) 
#       &&
#       $Proxy::Admin::Monitor::MonitorSocks > 0 
#      )
#      {
#	&Proxy::Admin::Monitor::SendToMonitors($logstring);
#      }
  }

1;


__END__


