#!/usr/bin/perl

my $perl = qx!which perl! ; chomp($perl);

my $path_to_proxy_lib        = $ARGV[0] || "/usr/local/lib/aproxy";
my $path_to_perl_interpreter = $perl;

while(<DATA>)
  {
    s/\+PATH_TO_PERL_INTERPRETER/$path_to_perl_interpreter/;
    s/\+PATH_TO_PROXY_LIB/$path_to_proxy_lib\//;
    print;
  }

######### application code after the __DATA__ token ################

__DATA__
#!+PATH_TO_PERL_INTERPRETER
#####################################################################
#
#  aproxy.pl       (c) 1999 by Dirk Barnikel <dirk.barnikel@gmx.de>
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License (http://www.gnu.org/copyleft/gpl.html)
#  for more details
#
######################################################################

package main; 
use lib "+PATH_TO_PROXY_LIB";
use Proxy; 
use strict;

#-------------------------------------------------------------------------------------

# install some signal-handlers
$SIG{PIPE} = 'IGNORE' ;
$SIG{INT}  = sub { exit 0 };
$SIG{TERM} = sub { exit 0 };
$SIG{HUP}  = sub { &Proxy::Config::loadConfigfile ;
		   &Proxy::Log::log_event("Signal HUP caught. Configfile reloaded!")
		 };


# check for cmd-line argument "-h" or "--help", print usage and exit
do { &print_usage() ; exit } if( grep { /-h/ || /--help/ } @ARGV);

# run the proxy-server
Proxy->InitServer();

#---------------------------------------------------------------------------------------

sub print_usage 
  {
    my $exec = "aproxy.pl";
    my $prog = "aPROXY";

    print << "__END_OF_USAGE__";

This is $prog $Proxy::Config::__VERSION (c) 1999 by Dirk Barnikel <dirk.barnikel\@gmx.de> 
THIS SOFTWARE COMES WITH ABSOLUTELY NO WARRANTY! USE AT YOUR OWN RISK!
	
Usage:
  
  $exec [<options>] [<config-file>] [<rules-file>]     

Possible options:

  -h or --help      show this help message

Default locations: 
  
  config-file: $ENV{HOME}/.aproxyrc
  rules-file : $ENV{HOME}/.aproxyrules

__END_OF_USAGE__
  }

__END__
